SystemOrganization addCategory: #'WebTester-API'!
SystemOrganization addCategory: #'WebTester-Selenium'!
SystemOrganization addCategory: #'WebTester-Selenium-Tests'!
SystemOrganization addCategory: #'WebTester-Selenium-Tests-Button'!
SystemOrganization addCategory: #'WebTester-Selenium-Tests-ComboBox'!
SystemOrganization addCategory: #'WebTester-Selenium-Tests-DragAndDrop'!
SystemOrganization addCategory: #'WebTester-Selenium-Tests-Frame'!
SystemOrganization addCategory: #'WebTester-Selenium-Tests-Link'!
SystemOrganization addCategory: #'WebTester-Selenium-Tests-TextField'!
SystemOrganization addCategory: #'WebTester-Selenium-Tests-UnitTestComponent'!

Trait named: #WtTClickable
	uses: {}
	category: 'WebTester-Selenium'!

!WtTClickable methodsFor: 'actions' stamp: 'LinusDeMeyere 1/4/2010 20:49'!
click
	self seleniumWebTester processCommand: 'click' withParams: (Array with: self locator location)! !

Trait named: #WtTEnabled
	uses: {}
	category: 'WebTester-Selenium'!

!WtTEnabled methodsFor: 'testing' stamp: 'LinusDeMeyere 1/4/2010 20:43'!
isEnabled
	^ (self seleniumWebTester processCommand: 'isEditable' withParams: (Array with: self locator location)) = 'true'! !

Trait named: #WtTPresent
	uses: {}
	category: 'WebTester-Selenium'!

!WtTPresent methodsFor: 'testing' stamp: 'LinusDeMeyere 1/4/2010 20:56'!
isPresent
	^ (self seleniumWebTester processCommand: 'isElementPresent' withParams: (Array with: self locator location)) = 'true'! !

TestResource subclass: #WtSeleniumWebTesterTestResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

WtSeleniumWebTesterTestResource class
	instanceVariableNames: 'defaultAppRoot webTester'!

WtSeleniumWebTesterTestResource class
	instanceVariableNames: 'defaultAppRoot webTester'!

!WtSeleniumWebTesterTestResource class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 14:06'!
defaultAppRoot
	^ defaultAppRoot! !

!WtSeleniumWebTesterTestResource class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 14:06'!
defaultAppRoot: anObject
	defaultAppRoot := anObject! !

!WtSeleniumWebTesterTestResource class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 16:06'!
webTester
	^ webTester! !

!WtSeleniumWebTesterTestResource class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 16:06'!
webTester: anObject
	webTester := anObject! !

!WtSeleniumWebTesterTestResource methodsFor: 'running' stamp: 'bkbag 6/10/2009 16:23'!
setUp
	|webTester|
	webTester := WtSeleniumWebTester new.
	webTester appRoot: self class defaultAppRoot.
	webTester browserType: '*chrome'.
	webTester start.
	self class webTester: webTester.! !

!WtSeleniumWebTesterTestResource methodsFor: 'running' stamp: 'BKBAG 5/10/2009 16:14'!
tearDown
	self class webTester stop.
	! !

GRObject subclass: #WtHtmlElement
	instanceVariableNames: 'locator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-API'!

WtHtmlElement subclass: #WtButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-API'!

!WtButton methodsFor: 'accessing' stamp: 'LinusDeMeyere 11/26/2009 21:13'!
click
	self subclassResponsibility! !

!WtButton methodsFor: 'accessing' stamp: 'LinusDeMeyere 11/26/2009 21:14'!
isEnabled
	self subclassResponsibility! !

!WtButton methodsFor: 'accessing' stamp: 'LinusDeMeyere 11/26/2009 21:13'!
isPresent
	self subclassResponsibility! !

WtButton subclass: #WtSeleniumButton
	uses: WtTEnabled + WtTClickable + WtTPresent
	instanceVariableNames: 'seleniumWebTester'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

WtSeleniumButton class
	uses: WtTEnabled classTrait + WtTClickable classTrait + WtTPresent classTrait
	instanceVariableNames: ''!

!WtSeleniumButton class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 20:16'!
createById: anId
	^ self locatedAt: (WtSeleniumLocator byId: anId)! !

!WtSeleniumButton class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 20:17'!
createByXPath: anXPath
	^ self locatedAt: (WtSeleniumLocator byXPath: anXPath)! !

!WtSeleniumButton methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 20:08'!
click
	seleniumWebTester processCommand: 'click' withParams: (Array with: self locator location).
	^seleniumWebTester! !

!WtSeleniumButton methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 20:08'!
isPresent
	^(seleniumWebTester processCommand: 'isElementPresent' withParams: (Array with: self locator location))
		= 'true'! !

!WtSeleniumButton methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 20:46'!
seleniumWebTester
	^ seleniumWebTester! !

!WtSeleniumButton methodsFor: 'accessing' stamp: 'LinusDeMeyere 11/26/2009 22:16'!
seleniumWebTester: aSeleniumWebTester
	seleniumWebTester := aSeleniumWebTester! !

WtHtmlElement subclass: #WtComboBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-API'!

!WtComboBox methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 16:45'!
isEnabled
	self subclassResponsibility ! !

!WtComboBox methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 21:27'!
isPresent
	self subclassResponsibility ! !

!WtComboBox methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 16:57'!
select: aLabel
	self subclassResponsibility ! !

!WtComboBox methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 18:19'!
selectNth: index
	self subclassResponsibility ! !

!WtComboBox methodsFor: 'accessing' stamp: 'BKBAG 5/16/2009 14:25'!
selectOptions
	self subclassResponsibility ! !

!WtComboBox methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 20:35'!
selectValue: aValue
	self subclassResponsibility ! !

!WtComboBox methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 14:28'!
selected
	self subclassResponsibility ! !

!WtComboBox methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 21:16'!
selectedIndex
	self subclassResponsibility ! !

!WtComboBox methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 21:23'!
selectedValue
	self subclassResponsibility ! !

WtComboBox subclass: #WtSeleniumComboBox
	uses: WtTEnabled + WtTPresent
	instanceVariableNames: 'seleniumWebTester'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

WtSeleniumComboBox class
	uses: WtTEnabled classTrait + WtTPresent classTrait
	instanceVariableNames: ''!

!WtSeleniumComboBox class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 20:06'!
createById: anId
	^ self locatedAt: (WtSeleniumLocator byId: anId)! !

!WtSeleniumComboBox methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 20:06'!
select: aLabel
	seleniumWebTester processCommand: 'select' withParams: (Array with: self locator location with: 'label=',aLabel).
	^seleniumWebTester! !

!WtSeleniumComboBox methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 20:06'!
selectNth: index
	seleniumWebTester processCommand: 'select' withParams: (Array with: self locator location with: 'index=', (index-1) asString).
	^seleniumWebTester! !

!WtSeleniumComboBox methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 20:07'!
selectOptions
	^(seleniumWebTester processCommand: 'getSelectOptions' withParams: (Array with: self locator location))
		findTokens: ',' escapedBy: nil! !

!WtSeleniumComboBox methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 20:07'!
selectValue: aValue
	seleniumWebTester processCommand: 'select' withParams: (Array with: self locator location with: 'value=', aValue).
	^seleniumWebTester! !

!WtSeleniumComboBox methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 20:07'!
selected
	^(seleniumWebTester processCommand: 'getSelectedLabel' withParams: (Array with: self locator location))! !

!WtSeleniumComboBox methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 20:07'!
selectedIndex
	^(seleniumWebTester processCommand: 'getSelectedIndex' withParams: (Array with: self locator location))
		asInteger + 1! !

!WtSeleniumComboBox methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 20:07'!
selectedValue
	^(seleniumWebTester processCommand: 'getSelectedValue' withParams: (Array with: self locator location))! !

!WtSeleniumComboBox methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 20:46'!
seleniumWebTester
	^ seleniumWebTester! !

!WtSeleniumComboBox methodsFor: 'accessing' stamp: 'BKBAG 5/16/2009 15:09'!
seleniumWebTester: aSeleniumWebTester
	seleniumWebTester := aSeleniumWebTester! !

WtHtmlElement subclass: #WtDraggable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-API'!

!WtDraggable methodsFor: 'actions' stamp: 'LinusDeMeyere 12/11/2009 16:18'!
dropOn: aDroppable
	self subclassResponsibility! !

WtDraggable subclass: #WtSeleniumDraggable
	instanceVariableNames: 'seleniumWebTester'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

!WtSeleniumDraggable class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 20:22'!
createById: anId
	^ self locatedAt: (WtSeleniumLocator byId: anId)! !

!WtSeleniumDraggable methodsFor: 'actions' stamp: 'LinusDeMeyere 1/4/2010 20:20'!
dropOn: aDroppable
	seleniumWebTester processCommand: 'dragAndDropToObject' withParams: (Array with: self locator location with: aDroppable locator location).
	^ seleniumWebTester! !

!WtSeleniumDraggable methodsFor: 'accessing' stamp: 'LinusDeMeyere 12/11/2009 16:44'!
seleniumWebTester: aSeleniumWebTester
	seleniumWebTester := aSeleniumWebTester! !

WtHtmlElement subclass: #WtDroppable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-API'!

WtDroppable subclass: #WtSeleniumDroppable
	instanceVariableNames: 'seleniumWebTester'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

!WtSeleniumDroppable class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 20:22'!
createById: anId
	^ self locatedAt: (WtSeleniumLocator byId: anId)! !

!WtSeleniumDroppable methodsFor: 'accessing' stamp: 'LinusDeMeyere 12/11/2009 16:44'!
seleniumWebTester: aSeleniumWebTester
	seleniumWebTester := aSeleniumWebTester! !

WtHtmlElement subclass: #WtFrame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-API'!

!WtFrame methodsFor: 'accessing' stamp: 'bkbag 6/10/2009 17:10'!
select
	self subclassResponsibility! !

WtFrame subclass: #WtSeleniumFrame
	instanceVariableNames: 'seleniumWebTester'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

!WtSeleniumFrame class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 20:16'!
createById: anId
	^ self locatedAt: (WtSeleniumLocator byId: anId)! !

!WtSeleniumFrame class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 20:04'!
parent
	^ self locatedAt: WtSeleniumLocator parent! !

!WtSeleniumFrame class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 20:05'!
top
	^ self locatedAt: WtSeleniumLocator top! !

!WtSeleniumFrame methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 20:03'!
select
	^(seleniumWebTester processCommand: 'selectFrame' withParams: (Array with: locator location))
		= 'true'! !

!WtSeleniumFrame methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 21:02'!
seleniumWebTester
	^ seleniumWebTester! !

!WtSeleniumFrame methodsFor: 'accessing' stamp: 'bkbag 6/10/2009 17:07'!
seleniumWebTester: aSeleniumWebTester
	seleniumWebTester := aSeleniumWebTester! !

!WtHtmlElement class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/3/2010 21:29'!
locatedAt: aLocator
	^ self basicNew
		initializeWithLocator: aLocator;
		yourself.! !

!WtHtmlElement methodsFor: 'initialization' stamp: 'LinusDeMeyere 1/3/2010 21:30'!
initializeWithLocator: aLocator
	self initialize.
	locator := aLocator! !

!WtHtmlElement methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/3/2010 21:30'!
locator
	^ locator! !

WtHtmlElement subclass: #WtLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-API'!

!WtLink methodsFor: 'accessing' stamp: 'bkbag 5/21/2009 16:01'!
click
	self subclassResponsibility! !

!WtLink methodsFor: 'accessing' stamp: 'bkbag 5/20/2009 16:10'!
isPresent
	self subclassResponsibility! !

WtLink subclass: #WtSeleniumLink
	uses: WtTClickable + WtTPresent
	instanceVariableNames: 'seleniumWebTester'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

WtSeleniumLink class
	uses: WtTClickable classTrait + WtTPresent classTrait
	instanceVariableNames: ''!

!WtSeleniumLink class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 20:16'!
createById: anId
	^ self locatedAt: (WtSeleniumLocator byId: anId)! !

!WtSeleniumLink class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 20:17'!
createByText: aLink
	^ self locatedAt: (WtSeleniumLocator byLink: aLink)! !

!WtSeleniumLink class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 20:18'!
createByXPath: anXPath
	^ self locatedAt: (WtSeleniumLocator byXPath: anXPath)! !

!WtSeleniumLink methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 20:01'!
click
	seleniumWebTester processCommand: 'click' withParams: (Array with: self locator location).
	^seleniumWebTester! !

!WtSeleniumLink methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 21:02'!
seleniumWebTester
	^ seleniumWebTester! !

!WtSeleniumLink methodsFor: 'accessing' stamp: 'bkbag 5/20/2009 16:29'!
seleniumWebTester: anObject
	seleniumWebTester := anObject! !

WtHtmlElement subclass: #WtTextField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-API'!

WtTextField subclass: #WtSeleniumTextField
	uses: WtTEnabled + WtTPresent
	instanceVariableNames: 'seleniumWebTester'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

WtSeleniumTextField class
	uses: WtTEnabled classTrait + WtTPresent classTrait
	instanceVariableNames: ''!

!WtSeleniumTextField class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 20:17'!
createById: anId
	^ self locatedAt: (WtSeleniumLocator byId: anId)! !

!WtSeleniumTextField class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 20:17'!
createByXPath: anXPath
	^ self locatedAt: (WtSeleniumLocator byXPath: anXPath)! !

!WtSeleniumTextField methodsFor: 'testing' stamp: 'LinusDeMeyere 11/29/2009 23:09'!
isEmpty
	^ self text isEmpty! !

!WtSeleniumTextField methodsFor: 'actions' stamp: 'LinusDeMeyere 1/4/2010 20:43'!
isEnabled
	^ (self seleniumWebTester processCommand: 'isEditable' withParams: (Array with: self locator location)) = 'true'! !

!WtSeleniumTextField methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 20:41'!
seleniumWebTester
	^ seleniumWebTester! !

!WtSeleniumTextField methodsFor: 'accessing' stamp: 'LinusDeMeyere 11/28/2009 17:21'!
seleniumWebTester: aSeleniumWebTester
	seleniumWebTester := aSeleniumWebTester! !

!WtSeleniumTextField methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 19:58'!
text
	^ (seleniumWebTester processCommand: 'getValue' withParams: (Array with: self locator location))! !

!WtSeleniumTextField methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 19:58'!
text: aValue
	^ (seleniumWebTester processCommand: 'type' withParams: (Array with: self locator location with: aValue))! !

!WtTextField methodsFor: 'testing' stamp: 'LinusDeMeyere 11/28/2009 17:18'!
isEmpty
	self subclassResponsibility! !

!WtTextField methodsFor: 'testing' stamp: 'LinusDeMeyere 11/29/2009 22:41'!
isEnabled
	self subclassResponsibility! !

!WtTextField methodsFor: 'testing' stamp: 'LinusDeMeyere 11/28/2009 17:15'!
isPresent
	self subclassResponsibility! !

!WtTextField methodsFor: 'accessing' stamp: 'LinusDeMeyere 11/28/2009 17:19'!
text
	self subclassResponsibility! !

!WtTextField methodsFor: 'accessing' stamp: 'LinusDeMeyere 11/28/2009 17:20'!
text: aText
	self subclassResponsibility! !

GRObject subclass: #WtLocator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-API'!

!WtLocator methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 19:14'!
location
	self subclassResponsibility! !

WtLocator subclass: #WtSeleniumLocator
	instanceVariableNames: 'locatorType argument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

!WtSeleniumLocator class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 19:55'!
byId: anId
	^ self basicNew
		initializeWithLocatorType: 'id' argument: anId;
		yourself! !

!WtSeleniumLocator class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 19:56'!
byLink: aLink
	^ self basicNew
		initializeWithLocatorType: 'link' argument: aLink;
		yourself! !

!WtSeleniumLocator class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 19:56'!
byXPath: anXPath
	^ self basicNew
		initializeWithLocatorType: 'xpath' argument: anXPath;
		yourself! !

!WtSeleniumLocator class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 20:04'!
parent
	^ self basicNew
		initializeWithLocatorType: 'relative' argument: 'parent';
		yourself! !

!WtSeleniumLocator class methodsFor: 'instance creation' stamp: 'LinusDeMeyere 1/4/2010 20:04'!
top
	^ self basicNew
		initializeWithLocatorType: 'relative' argument: 'top';
		yourself! !

!WtSeleniumLocator methodsFor: 'initialization' stamp: 'LinusDeMeyere 1/4/2010 19:19'!
initializeWithLocatorType: aLocatorType argument: anArgument
	self initialize.
	locatorType := aLocatorType.
	argument := anArgument! !

!WtSeleniumLocator methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/4/2010 19:45'!
location
	^ locatorType , '=' , argument! !

!HTTPSocket class methodsFor: '*WebTester-Selenium' stamp: 'BartGauquie 12/7/2009 21:17'!
httpGetDocumentForBrakkeSeleniumServer: url args: args accept: mimeType request: requestString
	"Return the exact contents of a web object. Asks for the given MIME 
type. If mimeType is nil, use 'text/html'. An extra requestString may be 
submitted and must end with crlf.  The parsed header is saved. Use a 
proxy server if one has been registered.  tk 7/23/97 17:12"
	"Note: To fetch raw data, you can use the MIME type 
'application/octet-stream'."

	| serverName serverAddr port sock header length bare page list firstData 
aStream index connectToHost connectToPort type newUrl |
	Socket initializeNetwork.
	bare := (url asLowercase beginsWith: 'http://') 
		ifTrue: [url copyFrom: 8 to: url size]
		ifFalse: [url].
	bare := bare copyUpTo: $#.  "remove fragment, if specified"
	serverName := bare copyUpTo: $/.
	page := bare copyFrom: serverName size + 1 to: bare size.
	(serverName includes: $:) 
		ifTrue: [ index := serverName indexOf: $:.
			port := (serverName copyFrom: index+1 to: serverName size) asNumber.
			serverName := serverName copyFrom: 1 to: index-1. ]
		ifFalse: [ port := self defaultPort ].
	page size = 0 ifTrue: [page := '/'].
	"add arguments"
	args ifNotNil: [page := page, (self argString: args) ].


	(self shouldUseProxy: serverName)
		ifFalse: [ 
			connectToHost := serverName.
			connectToPort := port ]
		ifTrue:  [
			page := 'http://', serverName, ':', port printString, page.		"put back 
together"
			connectToHost := self httpProxyServer.
			connectToPort := self httpProxyPort].
	

	serverAddr := NetNameResolver addressForName: connectToHost timeout: 20.
	serverAddr ifNil: [
		^ 'Could not resolve the server named: ', connectToHost].

3 timesRepeat: [
	sock := HTTPSocket new.
	sock connectTo: serverAddr port: connectToPort.
	(sock waitForConnectionFor: 30 ifTimedOut: [false]) ifFalse: [
		Socket deadServer: connectToHost.  sock destroy.
		^ 'Server ',connectToHost,' is not responding'].
	"Transcript cr;show: url; cr.
	Transcript show: page; cr."
	sock sendCommand: 'GET ', page, ' HTTP/1.0', String crlf, 
		(mimeType ifNotNil: ['ACCEPT: ', mimeType,  String crlf] ifNil: ['']),
		'ACCEPT: text/html',  String crlf,	"Always accept plain text"
		HTTPProxyCredentials,
		HTTPBlabEmail,	"may be empty"
		requestString,	"extra user request. Authorization"
		self userAgentString,  String crlf,
		'Host: ', serverName, ':', port printString,  String crlf.	"blank line 
automatically added"

	list := sock getResponseUpTo:  String crlf,  String crlf ignoring: String cr. "list = header, CrLf, CrLf, 
beginningOfData"
	header := list at: 1.
	"Transcript show: page; cr; show: header; cr."
	firstData := list at: 3.
	header isEmpty 
		ifTrue: [aStream := 'server aborted early']
		ifFalse: [
			"dig out some headers"
			sock header: header.
			length := sock getHeader: 'content-length'.
			length 
				ifNil: [
	 		       ((sock getHeader: 'connection') = 'close')
	   				   ifTrue: [length := firstData size]]
				ifNotNil: [ length := length asNumber ].
			type := sock getHeader: 'content-type'.
			sock responseCode first = $3 ifTrue: [
				newUrl := sock getHeader: 'location'.
				newUrl ifNotNil: [ 
					Transcript show: 'redirecting to ', newUrl; cr.
					sock destroy.
					newUrl := self expandUrl: newUrl ip: serverAddr port: connectToPort.
					^self httpGetDocument: newUrl args: args  accept: mimeType request: requestString] ].
			aStream := sock getRestOfBuffer: firstData totalLength: length.
			"a 400-series error"
			sock responseCode first = $4 ifTrue: [^ header, aStream contents].
			].
	sock destroy.	"Always OK to destroy!!"
	aStream class ~~ String ifTrue: [
 		^ MIMEDocument contentType: type content: aStream contents url: url].
	aStream = 'server aborted early' ifTrue: [ ^aStream ].
	].

{'HTTPSocket class>>httpGetDocument:args:accept:request:'. aStream. url} inspect.

	^'some other bad thing happened!!'! !

!HTTPSocket class methodsFor: '*WebTester-Selenium' stamp: 'BartGauquie 12/7/2009 21:16'!
httpGetForBrakkeSeleniumServer: url args: args accept: mimeType request: requestString
	"Return the exact contents of a web object. Asks for the given MIME type. If mimeType is nil, use 'text/html'. The parsed header is saved. Use a proxy server if one has been registered.  tk 7/23/97 17:12"
	"Note: To fetch raw data, you can use the MIME type 'application/octet-stream'."

	| document |
	document := self httpGetDocumentForBrakkeSeleniumServer: url args: args  accept: mimeType request: requestString.
	(document isString) ifTrue: [
		"strings indicate errors"
		^ document ].

	^ (RWBinaryOrTextStream with: document content) reset
! !

WAComponent subclass: #WtButtonMockApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-Button'!

!WtButtonMockApplication methodsFor: 'rendering' stamp: 'LinusDeMeyere 11/26/2009 22:55'!
renderContentOn: html
	html form with: [
		html button 
			id: 'buttonId';
			callback: [self inform: 'you clicked on the button'];
			with: 'buttontext'.
		html button 
			id: 'disabledbuttonId';
			disabled: true;
			with: 'disabledbuttontext'
	]! !

WAComponent subclass: #WtComboBoxMockApplication
	instanceVariableNames: 'elements selectedElementAfterOnChangeEvent selectedElementForValueComboBoxAfterOnChangeEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-ComboBox'!

!WtComboBoxMockApplication methodsFor: 'initialization' stamp: 'BKBAG 5/17/2009 17:41'!
initialize
	super initialize.
	elements := OrderedCollection new.
	elements
		add: (WtComboBoxMockElement new aValue: ''; label: '');
		add: (WtComboBoxMockElement new aValue: 'Value1'; label: 'Label1');
		add: (WtComboBoxMockElement new aValue: 'Value2'; label: 'Label2');
		add: (WtComboBoxMockElement new aValue: 'Value3'; label: 'Label3').
	selectedElementAfterOnChangeEvent := elements third.! !

!WtComboBoxMockApplication methodsFor: 'rendering' stamp: 'BKBAG 5/17/2009 21:26'!
renderContentOn: html 
	html form with:
		[html select
			id: 'comboBoxSelectId';
			list: elements;
			selected: elements third;
			labels: [:aComboBoxMockElement| aComboBoxMockElement label].
		html select
			id: 'disabledComboBoxId';			
			disabled;
			list: elements;
			selected: elements third;
			labels: [:aComboBoxMockElement| aComboBoxMockElement label].
		html select
			id: 'submitAfterSelectComboBoxId';
			onChange: 'submit()';
			list: elements;
			selected: selectedElementAfterOnChangeEvent;
			callback: [:selectedElement | selectedElementAfterOnChangeEvent := selectedElement];
			labels: [:aComboBoxMockElement| aComboBoxMockElement label].
		[|htmlSelect| 
			htmlSelect := html select.
			htmlSelect 
				id: 'comboBoxWithValuesId';
				labels: [:aComboBoxMockElement| aComboBoxMockElement label].
			htmlSelect with: 
				[
			elements do: [:each|
				html option
					value: each aValue;
					selected: (each aValue = elements third aValue);
					with: each label]]] value.		
	]! !

WAComponent subclass: #WtComponentHolder
	instanceVariableNames: 'componentUnderTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

WtComponentHolder class
	instanceVariableNames: 'createComponentBlock'!

WtComponentHolder class
	instanceVariableNames: 'createComponentBlock'!

!WtComponentHolder class methodsFor: 'accessing' stamp: 'BKBAG 5/11/2009 20:28'!
createComponentBlock
	^ createComponentBlock! !

!WtComponentHolder class methodsFor: 'accessing' stamp: 'BKBAG 5/11/2009 20:28'!
createComponentBlock: aCreateComponentBlock
	createComponentBlock := aCreateComponentBlock! !

!WtComponentHolder methodsFor: 'accessing' stamp: 'JohanBrichau 6/18/2010 21:27'!
children
	^ Array with: componentUnderTest! !

!WtComponentHolder methodsFor: 'accessing' stamp: 'BKBAG 5/11/2009 20:29'!
componentUnderTest
	^ componentUnderTest! !

!WtComponentHolder methodsFor: 'accessing' stamp: 'BKBAG 5/11/2009 20:29'!
componentUnderTest: anObject
	componentUnderTest := anObject! !

!WtComponentHolder methodsFor: 'initialization' stamp: 'BKBAG 5/11/2009 20:29'!
initialize
	super initialize.
	self componentUnderTest: (self class createComponentBlock value)
	! !

!WtComponentHolder methodsFor: 'rendering' stamp: 'BKBAG 5/11/2009 20:29'!
renderContentOn: html
	html render: componentUnderTest.
	! !

WAComponent subclass: #WtDragAndDropMockApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-DragAndDrop'!

!WtDragAndDropMockApplication methodsFor: 'rendering' stamp: 'LinusDeMeyere 12/11/2009 19:27'!
renderContentOn: html
	html span
		id: 'draggableId';
		script: (html draggable revert: true);
		style: 'cursor: move';
		with: 'drag me'.
	html break.
	html div
		id: 'droppableId';
		script: (html droppable
			onDrop: (html updater
				id: 'messageId';
				callback: [:ajaxHtml | ajaxHtml text: 'something was dropped']));
		with: 'drop something on me'.
	html div id: 'messageId'; with: ''.
	html break.
	html anchor callback: ["do nothing"]; with: 'reset'.! !

WAComponent subclass: #WtFrameMockApplication
	instanceVariableNames: 'mockFrame1 mockFrame2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-Frame'!

!WtFrameMockApplication methodsFor: 'initialization' stamp: 'bkbag 6/10/2009 16:36'!
initialize
	super initialize.
	mockFrame1 := WtMockFrame1 new.
	mockFrame2 := WtMockFrame2 new.! !

!WtFrameMockApplication methodsFor: 'rendering' stamp: 'bkbag 6/10/2009 16:41'!
renderContentOn: html
	html paragraph:
		[html text: 'text in main frame'.].
	html iframe id: 'mockFrame1'; contents: mockFrame1.
	html break.
	html iframe id: 'mockFrame2'; contents: mockFrame2.
		! !

WAComponent subclass: #WtLinkMockApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-Link'!

!WtLinkMockApplication methodsFor: 'rendering' stamp: 'bkbag 5/21/2009 16:01'!
renderContentOn: html
	html form with: [
			html anchor 
				id: 'anchorId';
				callback: [self inform: 'you clicked on the link'];
				with: 'anchortext'
			]! !

WAComponent subclass: #WtMockApplication
	instanceVariableNames: 'expectedText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-UnitTestComponent'!

!WtMockApplication methodsFor: 'accessing' stamp: 'BKBAG 5/11/2009 20:36'!
expectedText
	^ expectedText! !

!WtMockApplication methodsFor: 'accessing' stamp: 'BKBAG 5/11/2009 20:36'!
expectedText: anObject
	expectedText := anObject! !

!WtMockApplication methodsFor: 'rendering' stamp: 'BKBAG 5/11/2009 20:36'!
renderContentOn: html 
	html text: self expectedText.! !

WAComponent subclass: #WtMockApplicationAccessingTheSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-UnitTestComponent'!

!WtMockApplicationAccessingTheSession methodsFor: 'rendering' stamp: 'BartGauquie 12/22/2009 21:13'!
renderContentOn: html
	html text: 'text from session: ', self session usingAMethodOfMySpecialSessionObject, '.'.
	html break.
	html text: 'I accessed the session'.! !

WAComponent subclass: #WtMockFrame1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-Frame'!

!WtMockFrame1 methodsFor: 'rendering' stamp: 'bkbag 6/10/2009 16:32'!
renderContentOn: html
	html text: 'text of mock frame 1'.! !

WAComponent subclass: #WtMockFrame2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-Frame'!

!WtMockFrame2 methodsFor: 'rendering' stamp: 'bkbag 6/10/2009 16:34'!
renderContentOn: html
	html text: 'text of mock frame 2'.! !

WAComponent subclass: #WtTextFieldMockApplication
	instanceVariableNames: 'inputValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-TextField'!

!WtTextFieldMockApplication methodsFor: 'rendering' stamp: 'LinusDeMeyere 11/29/2009 22:46'!
renderContentOn: html
	html form: [
		html textInput id: 'enabledTextInputId'; callback: [:value | inputValue := value]; with: inputValue.
		html textInput disabled: true; id: 'disabledTextInputId'; with: 'some disabled value'.
		html submitButton id: 'submitButtonId'; with: 'submit'.
		html break.
		inputValue isNil ifFalse: [html text: 'you entered: ' , inputValue].
	]! !

TestCase subclass: #WtSeleniumCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

!WtSeleniumCase commentStamp: 'BKBAG 5/10/2009 13:21' prior: 0!
A WtSeleniumCase is testcase you can extend to easily write selenium tests.

Instance Variables
	webTester:		<Object>

webTester
	- xxxxx
!

!WtSeleniumCase class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 17:05'!
defaultAppRoot
	self subclassResponsibility! !

!WtSeleniumCase class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 14:13'!
resources
	WtSeleniumWebTesterTestResource defaultAppRoot: (self defaultAppRoot).
	^Array with: WtSeleniumWebTesterTestResource! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'LinusDeMeyere 11/26/2009 21:09'!
buttonById: locator 
	^self webTester buttonById: locator! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'JanSabbe 12/22/2009 02:42'!
buttonByValue: value 
	^self webTester buttonByValue: value! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/2/2010 23:00'!
buttonByXPath: locator
	^ self webTester buttonByXPath: locator! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'BKBAG 5/16/2009 14:28'!
comboBox: locator
	^self webTester comboBox: locator! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'LinusDeMeyere 12/11/2009 16:53'!
draggableById: locator
	^ self webTester draggableById: locator! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'LinusDeMeyere 12/11/2009 16:53'!
droppableById: locator
	^ self webTester droppableById: locator! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'bkbag 6/10/2009 17:13'!
frame
	^self webTester frame! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 14:12'!
isTextPresent: aString
	^self webTester isTextPresent: aString! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'bkbag 5/20/2009 16:31'!
link: text
	^self webTester link: text! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'bkbag 5/20/2009 16:40'!
linkById: locator
	^self webTester linkById: locator! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/2/2010 23:15'!
linkByXPath: locator
	^self webTester linkByXPath: locator! !

!WtSeleniumCase methodsFor: 'actions' stamp: 'BartGauquie 11/27/2009 13:56'!
openAtDefault
	self openUrl: self class defaultAppRoot.! !

!WtSeleniumCase methodsFor: 'actions' stamp: 'BKBAG 5/10/2009 14:13'!
openUrl: anUrl
	self webTester openUrl: anUrl! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'LinusDeMeyere 11/28/2009 17:23'!
textFieldById: locator
	^ self webTester textFieldById: locator! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'JanSabbe 12/22/2009 02:41'!
textFieldByLabel: label
	^ self webTester textFieldByLabel: label! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'JanSabbe 12/22/2009 02:27'!
textFieldByXPath: locator
	^ self webTester textFieldByXPath: locator! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 16:32'!
title
	^self webTester title! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'LinusDeMeyere 12/15/2009 19:16'!
waitForElementPresent: locator
	^ self webTester waitForElementPresent: locator! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 17:33'!
waitForPageToLoad
	^self webTester waitForPageToLoad! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'LinusDeMeyere 12/12/2009 15:49'!
waitForTextNotPresent: someText
	^ self webTester waitForTextNotPresent: someText! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'LinusDeMeyere 12/11/2009 19:55'!
waitForTextPresent: someText
	^ self webTester waitForTextPresent: someText! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 16:13'!
webTester
	^WtSeleniumWebTesterTestResource webTester! !

WtSeleniumCase subclass: #WtSeleniumCaseExampleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests'!

!WtSeleniumCaseExampleTest commentStamp: 'BKBAG 5/10/2009 16:16' prior: 0!
A WtSeleniumCaseExampleTest is an example test case to show you how to write selenium tests using test case.

You only have to implement 
WtSeleniumCase class >> 
	defaultAppRoot
	^'http://www.google.be'

Instance Variables
!

!WtSeleniumCaseExampleTest class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 16:15'!
defaultAppRoot
	^'http://www.google.be'! !

!WtSeleniumCaseExampleTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 15:47'!
testGoogleQuery
	self openUrl: 'http://www.google.be/'.
	self should: (self isTextPresent: 'Google').! !

!WtSeleniumCaseExampleTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 15:47'!
testGoogleQuery2
	self openUrl: 'http://www.google.be/'.
	self should: (self isTextPresent: 'Google').! !

!WtSeleniumCaseExampleTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 16:15'!
testGoogleQuery3
	self openUrl: 'http://www.google.be/'.
	self should: (self isTextPresent: 'Google').! !

!WtSeleniumCaseExampleTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 16:15'!
testGoogleQuery4
	self openUrl: 'http://www.google.be/'.
	self should: (self isTextPresent: 'Google').! !

!WtSeleniumCaseExampleTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 16:15'!
testGoogleQuery5
	self openUrl: 'http://www.google.be/'.
	self should: (self isTextPresent: 'Google').! !

WtSeleniumCase subclass: #WtSeleniumOpenUrlAndTestTitleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests'!

!WtSeleniumOpenUrlAndTestTitleTest commentStamp: 'BKBAG 5/10/2009 13:19' prior: 0!
A WtSeleniumOpenUrlAndTestTitleTest tests 
	- opening an url
	- retrieving the title of the page
	- isTextPresent

Instance Variables
!

!WtSeleniumOpenUrlAndTestTitleTest class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 16:30'!
defaultAppRoot
	^'http://www.google.be'! !

!WtSeleniumOpenUrlAndTestTitleTest methodsFor: 'tests' stamp: 'BartGauquie 6/20/2010 20:31'!
testOpenUrl
	self openUrl: 'http://www.google.be/'.
	self should: ['Google' = self title].
	self assert: (self isTextPresent: 'Google.be aangeboden in').
	self deny: (self isTextPresent: 'TextNietGevonden').
! !

WtSeleniumCase subclass: #WtUnitTestComponentSeleniumCase
	instanceVariableNames: 'componentHolder componentUnderTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

WtUnitTestComponentSeleniumCase subclass: #WtSeleniumButtonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-Button'!

!WtSeleniumButtonTest methodsFor: 'accessing' stamp: 'LinusDeMeyere 11/26/2009 22:46'!
button
	^ self buttonById: 'buttonId'! !

!WtSeleniumButtonTest methodsFor: 'accessing' stamp: 'TestRunner 11/26/2009 22:51'!
disabledButton
	^ self buttonById: 'disabledbuttonId'! !

!WtSeleniumButtonTest methodsFor: 'tests' stamp: 'LinusDeMeyere 12/11/2009 19:17'!
setUp
	super setUp.
	self initComponent: [WtButtonMockApplication new].
	self openUrl: self componentUrl.! !

!WtSeleniumButtonTest methodsFor: 'tests' stamp: 'LinusDeMeyere 11/26/2009 22:47'!
testClickButton
	(self button) click waitForPageToLoad.
	self should: (self isTextPresent: 'you clicked on the button')! !

!WtSeleniumButtonTest methodsFor: 'tests' stamp: 'LinusDeMeyere 11/26/2009 22:48'!
testIsEnabled
	self should: self button isEnabled.
	self shouldnt: self disabledButton isEnabled.! !

!WtSeleniumButtonTest methodsFor: 'tests' stamp: 'LinusDeMeyere 11/26/2009 22:48'!
testIsPresent
	self should: (self button) isPresent.
	self should: (self disabledButton) isPresent.
	self shouldnt: (self link: 'notFoundIdOfButton') isPresent.! !

WtUnitTestComponentSeleniumCase subclass: #WtSeleniumComboBoxTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-ComboBox'!

!WtSeleniumComboBoxTest class methodsFor: 'accessing' stamp: 'BKBAG 5/16/2009 14:05'!
componentClassUnderTest
	^WtComboBoxMockApplication
	! !

!WtSeleniumComboBoxTest methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 14:36'!
comboBoxUnderTest
	^self comboBox: 'comboBoxSelectId'! !

!WtSeleniumComboBoxTest methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 21:12'!
comboBoxWithValues
	^self comboBox: 'comboBoxWithValuesId'! !

!WtSeleniumComboBoxTest methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 16:47'!
disabledComboBoxUnderTest
	^self comboBox: 'disabledComboBoxId'! !

!WtSeleniumComboBoxTest methodsFor: 'tests' stamp: 'LinusDeMeyere 12/11/2009 19:17'!
setUp
	super setUp.
	self initComponent: [ WtComboBoxMockApplication new ].
	self openUrl: self componentUrl.! !

!WtSeleniumComboBoxTest methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 17:32'!
submitAfterSelectComboBox
	^self comboBox: 'submitAfterSelectComboBoxId'! !

!WtSeleniumComboBoxTest methodsFor: 'tests' stamp: 'BKBAG 5/17/2009 16:48'!
testIsEnabled
	self should: self comboBoxUnderTest isEnabled.
	self deny: self disabledComboBoxUnderTest isEnabled.! !

!WtSeleniumComboBoxTest methodsFor: 'tests' stamp: 'BKBAG 5/17/2009 21:29'!
testIsPresent
	self should: self comboBoxUnderTest isPresent.
	self deny: (self comboBox: 'withAnIdNotOnTestPage') isPresent.! !

!WtSeleniumComboBoxTest methodsFor: 'tests' stamp: 'BKBAG 5/17/2009 16:59'!
testSelect
	self comboBoxUnderTest select: 'Label3'.
	self should: self comboBoxUnderTest selected = 'Label3'.
	
	self comboBoxUnderTest select: 'Label1'.
	self should: self comboBoxUnderTest selected = 'Label1'.
! !

!WtSeleniumComboBoxTest methodsFor: 'tests' stamp: 'BKBAG 5/17/2009 18:23'!
testSelectNth
	self comboBoxUnderTest selectNth: 1.
	self should: self comboBoxUnderTest selected = ''.

	self comboBoxUnderTest selectNth: 2.
	self should: self comboBoxUnderTest selected = 'Label1'.

	self comboBoxUnderTest selectNth: 4.	
	self should: self comboBoxUnderTest selected = 'Label3'.
	
! !

!WtSeleniumComboBoxTest methodsFor: 'tests' stamp: 'BKBAG 5/17/2009 14:35'!
testSelectOptions
	| selectOptions |
	selectOptions := self comboBoxUnderTest selectOptions.
	self should: selectOptions size = 4.
	self should: selectOptions first = ''.
	self should: selectOptions second = 'Label1'.
	self should: selectOptions third = 'Label2'.
	self should: selectOptions fourth = 'Label3'! !

!WtSeleniumComboBoxTest methodsFor: 'tests' stamp: 'BKBAG 5/17/2009 21:13'!
testSelectValue
	self comboBoxWithValues selectValue: ''.
	self should: self comboBoxWithValues selected = ''.

	self comboBoxWithValues selectValue: 'Value1'.
	self should: self comboBoxWithValues selected = 'Label1'.

	self comboBoxWithValues selectValue: 'Value3'.
	self should: self comboBoxWithValues selected = 'Label3'.
	
! !

!WtSeleniumComboBoxTest methodsFor: 'tests' stamp: 'BKBAG 5/17/2009 14:45'!
testSelected
	self should: self comboBoxUnderTest selected notNil.
	self should: self comboBoxUnderTest selected = 'Label2'.! !

!WtSeleniumComboBoxTest methodsFor: 'tests' stamp: 'BKBAG 5/17/2009 21:23'!
testSelectedIndex
	self should: self comboBoxUnderTest selectedIndex notNil.
	self should: self comboBoxUnderTest selectedIndex = 3.
	
	self should: self disabledComboBoxUnderTest selectedIndex = 3.! !

!WtSeleniumComboBoxTest methodsFor: 'tests' stamp: 'BKBAG 5/17/2009 21:24'!
testSelectedValue
	self should: self comboBoxWithValues selectedValue notNil.
	self should: self comboBoxWithValues selectedValue = 'Value2'.
! !

!WtSeleniumComboBoxTest methodsFor: 'tests' stamp: 'BKBAG 5/17/2009 18:23'!
testWaitForPageToLoad
	(self submitAfterSelectComboBox select: 'Label3') waitForPageToLoad.
	self should: self submitAfterSelectComboBox selected = 'Label3'.
	
	(self submitAfterSelectComboBox selectNth: 2) waitForPageToLoad.
	self should: self submitAfterSelectComboBox selected = 'Label1'.! !

WtUnitTestComponentSeleniumCase subclass: #WtSeleniumDragAndDropTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-DragAndDrop'!

!WtSeleniumDragAndDropTest methodsFor: 'running' stamp: 'LinusDeMeyere 12/11/2009 19:17'!
setUp
	super setUp.
	self initComponent: [WtDragAndDropMockApplication new].
	self openUrl: self componentUrl.! !

!WtSeleniumDragAndDropTest methodsFor: 'tests' stamp: 'LinusDeMeyere 12/11/2009 19:55'!
testDragAndDrop
	| draggable droppable |
	draggable := self draggableById: 'draggableId'.
	droppable := self droppableById: 'droppableId'.
	
	draggable dropOn: droppable.
	
	self waitForTextPresent: 'something was dropped'.! !

WtUnitTestComponentSeleniumCase subclass: #WtSeleniumLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-Link'!

!WtSeleniumLinkTest methodsFor: 'tests' stamp: 'bkbag 5/21/2009 16:02'!
linkByAnchorId
	^ self linkById: 'anchorId'! !

!WtSeleniumLinkTest methodsFor: 'tests' stamp: 'LinusDeMeyere 12/11/2009 19:17'!
setUp
	super setUp.
	self initComponent: [WtLinkMockApplication new].
	self openUrl: self componentUrl.! !

!WtSeleniumLinkTest methodsFor: 'tests' stamp: 'bkbag 5/21/2009 16:03'!
testClick
	(self linkByAnchorId click) waitForPageToLoad.
	self should: (self isTextPresent: 'you clicked on the link').! !

!WtSeleniumLinkTest methodsFor: 'tests' stamp: 'LinusDeMeyere 1/2/2010 23:38'!
testIsPresent
	self should: (self link: 'anchortext') isPresent.
	self shouldnt: (self link: 'notfoundtextolink') isPresent.
	self should: self linkByAnchorId isPresent.
	self shouldnt: (self linkById: 'notfoundAnchorId') isPresent! !

!WtSeleniumLinkTest methodsFor: 'tests' stamp: 'LinusDeMeyere 1/2/2010 23:40'!
testLinkByXPath
	self should: (self linkByXPath: '//a[contains(text(), ''anchortext'')]') isPresent.
	self shouldnt: (self linkByXPath: '//a[contains(text(), ''notfoundAnchorId'')]') isPresent! !

WtUnitTestComponentSeleniumCase subclass: #WtSeleniumSelectFrameTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-Frame'!

!WtSeleniumSelectFrameTest methodsFor: 'tests' stamp: 'LinusDeMeyere 12/11/2009 19:17'!
setUp
	super setUp.
	super initComponent: [WtFrameMockApplication new].
	self openUrl: self componentUrl.! !

!WtSeleniumSelectFrameTest methodsFor: 'tests' stamp: 'LinusDeMeyere 1/4/2010 18:54'!
testFrameIsSelected
	self should: (self isTextPresent: 'text in main frame').
	self shouldnt: (self isTextPresent: 'text of mock frame 1').
	self shouldnt: (self isTextPresent: 'text of mock frame 2').
	
	(self frame forId: 'mockFrame1') select.
	self shouldnt: (self isTextPresent: 'text in main frame').
	self should: (self isTextPresent: 'text of mock frame 1').
	self shouldnt: (self isTextPresent: 'text of mock frame 2').
	
	(self frame top) select.
	(self frame forId: 'mockFrame2') select.
	self shouldnt: (self isTextPresent: 'text in main frame').
	self shouldnt: (self isTextPresent: 'text of mock frame 1').
	self should: (self isTextPresent: 'text of mock frame 2').
	
	(self frame parent) select.
	self should: (self isTextPresent: 'text in main frame').
	self shouldnt: (self isTextPresent: 'text of mock frame 1').
	self shouldnt: (self isTextPresent: 'text of mock frame 2').
! !

WtUnitTestComponentSeleniumCase subclass: #WtSeleniumTextFieldTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-TextField'!

!WtSeleniumTextFieldTest methodsFor: 'accessing' stamp: 'LinusDeMeyere 11/29/2009 22:36'!
disabledTextField
	^ self textFieldById: 'disabledTextInputId'! !

!WtSeleniumTextFieldTest methodsFor: 'running' stamp: 'LinusDeMeyere 12/11/2009 19:17'!
setUp
	super setUp.
	self initComponent: [WtTextFieldMockApplication new].
	self openUrl: self componentUrl.! !

!WtSeleniumTextFieldTest methodsFor: 'accessing' stamp: 'LinusDeMeyere 11/29/2009 22:58'!
submitButton
	^ self buttonById: 'submitButtonId'! !

!WtSeleniumTextFieldTest methodsFor: 'tests' stamp: 'LinusDeMeyere 11/29/2009 23:09'!
testIsEmpty
	| submitButton |
	self textField text: ''.
	submitButton := self submitButton click waitForPageToLoad.
	self should: (self textField isEmpty).! !

!WtSeleniumTextFieldTest methodsFor: 'tests' stamp: 'LinusDeMeyere 11/29/2009 22:41'!
testIsEnabled
	self should: self textField isEnabled.
	self shouldnt: self disabledTextField isEnabled.! !

!WtSeleniumTextFieldTest methodsFor: 'tests' stamp: 'LinusDeMeyere 11/28/2009 18:58'!
testIsPresent
	self should: self textField isPresent.
	self should: self disabledTextField isPresent.
	self shouldnt: (self textFieldById: 'nonExistingTextInputId') isPresent.! !

!WtSeleniumTextFieldTest methodsFor: 'tests' stamp: 'LinusDeMeyere 11/29/2009 23:06'!
testTypeSomeTextInTextField
	| submitButton someTestInput |
	someTestInput := 'some test input'.
	self textField text: someTestInput.
	submitButton := self submitButton click waitForPageToLoad.
	self should: (self isTextPresent: someTestInput).
	self assert: someTestInput equals: (self textField text).! !

!WtSeleniumTextFieldTest methodsFor: 'accessing' stamp: 'LinusDeMeyere 11/29/2009 22:36'!
textField
	^ self textFieldById: 'enabledTextInputId'! !

WtUnitTestComponentSeleniumCase subclass: #WtUnitTestComponentAccessingTheSessionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-UnitTestComponent'!

!WtUnitTestComponentAccessingTheSessionTest methodsFor: 'tests' stamp: 'BartGauquie 12/22/2009 21:30'!
testWASessionCanBeAccessed
	self initComponent: [WtMockApplicationAccessingTheSession new] usingSession: WtMySpecialMockSession.
	self openUrl: self componentUrl.	

	self should: (self isTextPresent: 'text from session: this is text from this special object.').
	self should: (self isTextPresent: 'I accessed the session').! !

!WtUnitTestComponentSeleniumCase class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 17:03'!
componentUnderTestResourcePath
	^'webtestercomponenttesting'! !

!WtUnitTestComponentSeleniumCase class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 17:06'!
defaultAppRoot
	^'http://localhost:8080/seaside/'.! !

!WtUnitTestComponentSeleniumCase methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 17:17'!
componentUrl
	^self class defaultAppRoot , self class componentUnderTestResourcePath.! !

!WtUnitTestComponentSeleniumCase methodsFor: 'running' stamp: 'LinusDeMeyere 1/2/2010 22:09'!
initComponent: createComponentBlock
	WtComponentHolder createComponentBlock: createComponentBlock.
	componentUnderTest := WAAdmin 
		register: WtComponentHolder
		asApplicationAt: self class componentUnderTestResourcePath.
	componentUnderTest
		addLibrary: PTDeploymentLibrary;
		addLibrary: SUDeploymentLibrary;
		addLibrary: SUComponentLibrary.! !

!WtUnitTestComponentSeleniumCase methodsFor: 'running' stamp: 'BartGauquie 12/22/2009 21:27'!
initComponent: createComponentBlock usingSession: aSessionClass
	self initComponent: createComponentBlock.
	componentUnderTest preferenceAt: #sessionClass put: aSessionClass.! !

!WtUnitTestComponentSeleniumCase methodsFor: 'running' stamp: 'BKBAG 5/11/2009 20:32'!
tearDown
	super tearDown.
	componentUnderTest 
		ifNotNil: [WAAdmin defaultDispatcher unregister: componentUnderTest].
	WtComponentHolder createComponentBlock: nil.
! !

WtUnitTestComponentSeleniumCase subclass: #WtUnitTestComponentSeleniumExampleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-UnitTestComponent'!

!WtUnitTestComponentSeleniumExampleTest class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 17:22'!
componentClassUnderTest
	^WtMockApplication! !

!WtUnitTestComponentSeleniumExampleTest methodsFor: 'tests' stamp: 'LinusDeMeyere 12/11/2009 19:18'!
testMockApplicationTextContent
	self initComponent: [WtMockApplication new expectedText: 'text to be shown'].
	self openUrl: self componentUrl.
	
	self should: (self isTextPresent: 'text to be shown').
	! !

!WtUnitTestComponentSeleniumExampleTest methodsFor: 'tests' stamp: 'LinusDeMeyere 12/11/2009 19:18'!
testMockApplicationWithDifferentTextContent
	self initComponent: [WtMockApplication new expectedText: 'some different textmessage to be shown'].
	self openUrl: self componentUrl.
	
	self should: (self isTextPresent: 'some different textmessage to be shown').
	! !

TestCase subclass: #WtSeleniumStartStopTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests'!

!WtSeleniumStartStopTest commentStamp: 'BKBAG 5/10/2009 13:18' prior: 0!
A WtSeleniumStartStopTest tests starting and stopping browser.

Instance Variables
!

!WtSeleniumStartStopTest methodsFor: 'helper' stamp: 'BKBAG 11/23/2008 20:23'!
appRoot
	^'www.google.com'! !

!WtSeleniumStartStopTest methodsFor: 'helper' stamp: 'BKBAG 11/23/2008 21:52'!
defaultWebTester
	^ WtSeleniumWebTester new appRoot: 'http://www.google.com'! !

!WtSeleniumStartStopTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 13:13'!
testAutoAppendHttpToRootAppUrl
	| seleniumWebTester |
	seleniumWebTester := WtSeleniumWebTester new appRoot: 'www.google.com'.
	[seleniumWebTester start]
	ensure: [seleniumWebTester stop]! !

!WtSeleniumStartStopTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 13:14'!
testCanNotStartTwice
	| seleniumWebTester |
	seleniumWebTester := self defaultWebTester.
	[seleniumWebTester start.
	self
		should: [seleniumWebTester start]
		raise: Error
		withExceptionDo: [:anException | self assert: anException messageText = 'Can not start again']]
		ensure: [seleniumWebTester stop]! !

!WtSeleniumStartStopTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 13:14'!
testCanStartStopAndStartStop
	| seleniumWebTester |
	seleniumWebTester := self defaultWebTester.
	[seleniumWebTester start]
		ensure: [seleniumWebTester stop].
	[seleniumWebTester start]
		ensure: [seleniumWebTester stop]! !

!WtSeleniumStartStopTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 13:15'!
testIsStarted
	|seleniumWebTester|
	seleniumWebTester := self defaultWebTester.
	
	[self shouldnt: seleniumWebTester isStarted.
	seleniumWebTester start.]
	ensure: [
		self should: seleniumWebTester isStarted.	
		seleniumWebTester stop.
		
		self shouldnt: seleniumWebTester isStarted.	
		]! !

!WtSeleniumStartStopTest methodsFor: 'tests' stamp: 'BKBAG 11/23/2008 21:52'!
testSpecifyRootAppBeforeStarting
	| seleniumWebTester |
	seleniumWebTester := WtSeleniumWebTester new.
	self 
		should: [ seleniumWebTester start ]
		raise: Error
		withExceptionDo: 
			[ :anException | 
			self assert: anException messageText = 'Specify appRoot before starting' ]! !

!WtSeleniumStartStopTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 13:16'!
testStartStop
	|seleniumWebTester|
	seleniumWebTester := self defaultWebTester.
	
	[seleniumWebTester start.]
	ensure: [seleniumWebTester stop.]! !

TestCase subclass: #WtSequenceableCollectionAsSeleniumCommandParamsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests'!

!WtSequenceableCollectionAsSeleniumCommandParamsTest methodsFor: 'tests' stamp: 'bkbag 5/17/2009 11:21'!
testCollectionWithMoreElements
	|aCollection|
	
	aCollection := (Array with: 'value1' with: 'value2' with: 'value3').
	
	self should: aCollection asSeleniumCommandParams = '&1=value1&2=value2&3=value3'.! !

!WtSequenceableCollectionAsSeleniumCommandParamsTest methodsFor: 'tests' stamp: 'bkbag 5/17/2009 11:10'!
testCollectionWithOneElement
	|aCollection|
	
	aCollection := Array with: 'value1'.
	
	self should: aCollection asSeleniumCommandParams = '&1=value1'.! !

!WtSequenceableCollectionAsSeleniumCommandParamsTest methodsFor: 'tests' stamp: 'bkbag 5/17/2009 11:06'!
testEmptyCollection
	|anEmptyCollection|
	
	anEmptyCollection := Array new.
	
	self should: anEmptyCollection asSeleniumCommandParams = ''.! !

TestCase subclass: #WtTrySeleniumRCOutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests'!

!WtTrySeleniumRCOutTest commentStamp: 'BKBAG 5/10/2009 13:18' prior: 0!
A WtTrySeleniumRCOutTest is a raw tryout of the selenium rc in squeak - first demo.

Instance Variables
!

!WtTrySeleniumRCOutTest methodsFor: 'helper' stamp: 'BKBAG 11/23/2008 17:31'!
clickButton: id forSession: aSessionId
	|result|
	result := self commandToSeleniumRC: 'click&1=', id, '&sessionId=',aSessionId.
	self should: [result = 'OK']! !

!WtTrySeleniumRCOutTest methodsFor: 'helper' stamp: 'BKBAG 11/23/2008 16:26'!
closeBrowser: sessionId
	| result|
	result := self commandToSeleniumRC: 'testComplete&sessionId=', sessionId.
	self should: [result = 'OK'].! !

!WtTrySeleniumRCOutTest methodsFor: 'helper' stamp: 'BartGauquie 10/10/2009 10:46'!
commandToSeleniumRC: aCommandString
	^self requestToSeleniumRC: 'http://127.0.0.1:4444/selenium-server/?cmd=', aCommandString.! !

!WtTrySeleniumRCOutTest methodsFor: 'helper' stamp: 'BKBAG 5/10/2009 12:54'!
openBrowserToUrl: anUrl
	|result|
	result := self commandToSeleniumRC: 'getNewBrowserSession&1=*chrome&2=', anUrl.
	self should: [result beginsWith: 'OK,'].
	^result copyFrom: 4 to: result size. ! !

!WtTrySeleniumRCOutTest methodsFor: 'helper' stamp: 'BKBAG 11/23/2008 17:30'!
openPage: url forSession: aSessionId
	|result|
	result := self commandToSeleniumRC: 'open&1=', url, '&sessionId=',aSessionId.
	self should: [result = 'OK']! !

!WtTrySeleniumRCOutTest methodsFor: 'helper' stamp: 'BartGauquie 12/7/2009 21:19'!
requestToSeleniumRC: aRequestUrl
	|result|
	result := HTTPSocket httpGetForBrakkeSeleniumServer: aRequestUrl args: nil accept: '*/*' request: ''.
	(result isString)
		ifTrue: [self error: 'Could not get: ', aRequestUrl , ' error was: ', result]
		ifFalse: [^result contents].
				
! !

!WtTrySeleniumRCOutTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 13:12'!
testDoAGoogleQuery
	| sessionId |
	[
		sessionId := self openBrowserToUrl: 'http://www.google.com'.
		self 
			openPage: 'http://www.google.com/webhp'
			forSession: sessionId.
		self 
			textInput: 'q'
			typeValue: 'Squeak'
			forSession: sessionId.
		self 
			clickButton: 'btnG'
			forSession: sessionId.
		self should: [ (self title: sessionId) includesSubString: 'Google' ].
		]
	ensure: [
		self closeBrowser: sessionId
		]! !

!WtTrySeleniumRCOutTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 13:11'!
testOpenAndCloseBrowser
	| sessionId|

	[sessionId := self openBrowserToUrl: 'http://www.google.com'.]
	ensure: [self closeBrowser: sessionId.]! !

!WtTrySeleniumRCOutTest methodsFor: 'helper' stamp: 'BKBAG 11/23/2008 16:38'!
textInput: id typeValue: aValue forSession: aSessionId
	|result|
	result := self commandToSeleniumRC: 'type&1=', id, '&2=',aValue,'&sessionId=',aSessionId.
	self should: [result = 'OK']! !

!WtTrySeleniumRCOutTest methodsFor: 'helper' stamp: 'BKBAG 11/23/2008 17:36'!
title: sessionId
	|result|
	result := self commandToSeleniumRC: 'getTitle&sessionId=',sessionId.
	self should: [result beginsWith: 'OK'].
	^result copyFrom: 4 to: result size. ! !

!SequenceableCollection methodsFor: '*WebTester-Selenium' stamp: 'bkbag 5/17/2009 11:57'!
asSeleniumCommandParams
	^String streamContents: 
		[:stream|
			(self withIndexCollect: [:element :atIndex | '&', atIndex asString, '=', element encodeForHTTP])
			 asStringOn: stream delimiter: '' ].! !

WASession subclass: #WtMySpecialMockSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-UnitTestComponent'!

!WtMySpecialMockSession methodsFor: 'as yet unclassified' stamp: 'BartGauquie 12/22/2009 21:13'!
usingAMethodOfMySpecialSessionObject
	^'this is text from this special object'! !

Object subclass: #WtComboBoxMockElement
	instanceVariableNames: 'aValue label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests-ComboBox'!

!WtComboBoxMockElement methodsFor: 'accessing' stamp: 'BKBAG 5/16/2009 14:12'!
aValue
	^ aValue! !

!WtComboBoxMockElement methodsFor: 'accessing' stamp: 'BKBAG 5/16/2009 14:12'!
aValue: anObject
	aValue := anObject! !

!WtComboBoxMockElement methodsFor: 'accessing' stamp: 'BKBAG 5/16/2009 14:11'!
label
	^ label! !

!WtComboBoxMockElement methodsFor: 'accessing' stamp: 'BKBAG 5/16/2009 14:11'!
label: anObject
	label := anObject! !

Object subclass: #WtFrameBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-API'!

!WtFrameBuilder commentStamp: 'bkbag 6/10/2009 17:02' prior: 0!
A WtFrameBuilder is class which builds WtFrame objects.

Instance Variables
!

!WtFrameBuilder methodsFor: 'instance-creation' stamp: 'bkbag 6/10/2009 17:05'!
forId: aFrameId
	self subclassResponsibility! !

!WtFrameBuilder methodsFor: 'instance-creation' stamp: 'bkbag 6/10/2009 17:24'!
parent
	self subclassResponsibility! !

!WtFrameBuilder methodsFor: 'instance-creation' stamp: 'bkbag 6/10/2009 17:24'!
top
	self subclassResponsibility! !

WtFrameBuilder subclass: #WtSeleniumFrameBuilder
	instanceVariableNames: 'seleniumWebTester'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

!WtSeleniumFrameBuilder methodsFor: 'instance-creation' stamp: 'LinusDeMeyere 1/4/2010 18:47'!
forId: aFrameId
	^ (WtSeleniumFrame createById: aFrameId) seleniumWebTester: seleniumWebTester; yourself.! !

!WtSeleniumFrameBuilder methodsFor: 'instance-creation' stamp: 'LinusDeMeyere 1/4/2010 19:02'!
parent
	^ (WtSeleniumFrame parent) seleniumWebTester: seleniumWebTester; yourself.! !

!WtSeleniumFrameBuilder methodsFor: 'accessing' stamp: 'bkbag 6/10/2009 17:04'!
seleniumWebTester: aSeleniumWebTester
	seleniumWebTester := aSeleniumWebTester! !

!WtSeleniumFrameBuilder methodsFor: 'instance-creation' stamp: 'LinusDeMeyere 1/4/2010 19:01'!
top
	^ (WtSeleniumFrame top) seleniumWebTester: seleniumWebTester; yourself.! !

Object subclass: #WtWebTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-API'!

!WtWebTester commentStamp: 'BKBAG 5/10/2009 13:19' prior: 0!
WtWebTester defines an API for web tests

Instance Variables
!

WtWebTester subclass: #WtSeleniumWebTester
	instanceVariableNames: 'appRoot sessionId browserType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

!WtSeleniumWebTester commentStamp: 'BKBAG 5/10/2009 13:20' prior: 0!
A WtSeleniumWebTester is a Selenium implementation for WtWebTester.

Instance Variables
	appRoot:		<Object>
	sessionId:		<Object>

appRoot
	- xxxxx

sessionId
	- xxxxx
!

!WtSeleniumWebTester methodsFor: 'initialize-release' stamp: 'BKBAG 11/25/2008 12:12'!
appRoot
	^appRoot! !

!WtSeleniumWebTester methodsFor: 'initialize-release' stamp: 'BKBAG 11/23/2008 20:40'!
appRoot: anAppRoot
	appRoot := anAppRoot ! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 17:09'!
browserType
	^ browserType ifNil: [browserType := self defaultBrowser]! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 17:06'!
browserType: aBrowserType
	browserType := aBrowserType! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'LinusDeMeyere 11/26/2009 21:11'!
buttonById: locator
	^(WtSeleniumButton createById: locator) seleniumWebTester: self; yourself.! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'JanSabbe 12/22/2009 02:47'!
buttonByValue: value
	^self buttonByXPath: '//input[contains(@value,''',value,''')]'.! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'JanSabbe 12/22/2009 02:47'!
buttonByXPath: locator
	^(WtSeleniumButton createByXPath: locator) seleniumWebTester: self; yourself.! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/3/2010 21:53'!
comboBox: locator
	^ (WtSeleniumComboBox createById: locator) seleniumWebTester: self; yourself.! !

!WtSeleniumWebTester methodsFor: 'private' stamp: 'BKBAG 11/23/2008 21:02'!
commandToSeleniumRC: aCommandString 
	^ self requestToSeleniumRC: 'http://' , self defaultSeleniumHost , ':' , self defaultSeleniumPort printString , '/selenium-server/?cmd=' , aCommandString! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 17:05'!
defaultBrowser
	^'*chrome'! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'BartGauquie 10/10/2009 11:10'!
defaultSeleniumHost
	^'127.0.0.1'! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'BKBAG 11/23/2008 21:01'!
defaultSeleniumPort
	^4444! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'LinusDeMeyere 12/11/2009 16:43'!
draggableById: locator
	^ (WtSeleniumDraggable createById: locator) seleniumWebTester: self; yourself.! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'LinusDeMeyere 12/11/2009 16:44'!
droppableById: locator
	^ (WtSeleniumDroppable createById: locator) seleniumWebTester: self; yourself.! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'bkbag 6/10/2009 17:10'!
frame
	^WtSeleniumFrameBuilder new seleniumWebTester: self; yourself.! !

!WtSeleniumWebTester methodsFor: 'initialize-release' stamp: 'BartGauquie 10/18/2009 17:51'!
fullAppRoot
	(self isAppRootSpecified)
		ifFalse:[^nil].
	(self appRoot beginsWith: 'http://')
		ifTrue: [^appRoot]
		ifFalse: [^'http://', appRoot].! !

!WtSeleniumWebTester methodsFor: 'initialize-release' stamp: 'BKBAG 11/25/2008 12:13'!
isAppRootSpecified
	^self appRoot isNil not.! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'BKBAG 11/23/2008 21:26'!
isStarted
	^sessionId isNil not.! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'bkbag 5/17/2009 12:19'!
isTextPresent: aString
	^(self processCommand: 'isTextPresent' withParams: (Array with: aString))
		= 'true'! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'bkbag 5/20/2009 16:30'!
link: text
	^(WtSeleniumLink createByText: text) seleniumWebTester: self; yourself.! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'bkbag 5/20/2009 16:41'!
linkById: locator
	^(WtSeleniumLink createById: locator) seleniumWebTester: self; yourself.! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/2/2010 23:15'!
linkByXPath: locator
	^(WtSeleniumLink createByXPath: locator) seleniumWebTester: self; yourself.! !

!WtSeleniumWebTester methodsFor: 'private' stamp: 'BKBAG 5/17/2009 17:30'!
maxWaitTimeForPageToLoadInMillis
	^600000000! !

!WtSeleniumWebTester methodsFor: 'actions' stamp: 'bkbag 4/17/2009 20:31'!
openUrl: anUrl
	|result|
	result := self commandToSeleniumRC: 'open&1=', anUrl, '&sessionId=', sessionId.
	(result beginsWith: 'OK')
	ifFalse: [self error: 'Could not open page ', anUrl, ' result was: ', result].! !

!WtSeleniumWebTester methodsFor: 'private' stamp: 'BKBAG 5/17/2009 17:37'!
processCommand: commandName withParams: arrayOfParams 
	| resultOfCommand |
	resultOfCommand := self commandToSeleniumRC: commandName, arrayOfParams asSeleniumCommandParams, '&sessionId=', sessionId.
	(resultOfCommand beginsWith: 'OK') ifFalse: 
		[ self error: 'Could not execute command ' , commandName , ' with params: ' , arrayOfParams asString , ' result was: ' , resultOfCommand ].
	(resultOfCommand = 'OK')
		ifTrue: [^ true]
		ifFalse: [^ resultOfCommand allButFirst: 3].! !

!WtSeleniumWebTester methodsFor: 'private' stamp: 'BartGauquie 12/7/2009 21:16'!
requestToSeleniumRC: aRequestUrl
	|result|
	result := HTTPSocket httpGetForBrakkeSeleniumServer: aRequestUrl args: nil accept: '*/*' request: ''.
	(result isString)
		ifTrue: [self error: 'Could not get: ', aRequestUrl , ' error was: ', result]
		ifFalse: [^result contents].
				
! !

!WtSeleniumWebTester methodsFor: 'initialize-release' stamp: 'BKBAG 5/17/2009 17:07'!
start
	|result|
	(self isAppRootSpecified)
		ifFalse: [self error: 'Specify appRoot before starting'].
	(self isStarted)
		ifTrue: [self error: 'Can not start again'].
	result := self commandToSeleniumRC: 'getNewBrowserSession&1=', self browserType, '&2=', self fullAppRoot.
	(result beginsWith: 'OK,')
		ifTrue: [sessionId  := result copyFrom: 4 to: result size]
		ifFalse: [self error: 'Error starting, unexpected result: ''', result, ''''].
! !

!WtSeleniumWebTester methodsFor: 'initialize-release' stamp: 'BKBAG 11/23/2008 21:28'!
stop
	|result|
	result := self commandToSeleniumRC: 'testComplete&sessionId=', sessionId.
	(result = 'OK')
		ifFalse: [self error: 'problem stopping browser', result]
		ifTrue: [sessionId := nil]! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'LinusDeMeyere 11/28/2009 17:24'!
textFieldById: locator
	^ (WtSeleniumTextField createById: locator) seleniumWebTester: self; yourself.! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'JanSabbe 12/22/2009 02:56'!
textFieldByLabel: label
	^ self textFieldByXPath: '//label[contains(text(),''' , label , ''')]/..//input | //label[contains(text(),''' , label , ''')]/..//textarea'! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'JanSabbe 12/22/2009 02:23'!
textFieldByXPath: locator
	^ (WtSeleniumTextField createByXPath: locator) seleniumWebTester: self; yourself.! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'bkbag 5/17/2009 12:22'!
title
	^self processCommand: 'getTitle' withParams: Array new.! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'LinusDeMeyere 12/15/2009 19:29'!
waitForElementPresent: locator
	^ (self processCommand: 'waitForElementPresent' withParams: (Array with: locator)) = 'true'! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 17:39'!
waitForPageToLoad	
	^(self processCommand: 'waitForPageToLoad' withParams: (Array with: self maxWaitTimeForPageToLoadInMillis asString))
		= 'true'! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'LinusDeMeyere 12/12/2009 15:49'!
waitForTextNotPresent: someText
	^ (self processCommand: 'waitForTextNotPresent'
		withParams: (Array with: someText with: self maxWaitTimeForPageToLoadInMillis asString)) = 'true'! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'LinusDeMeyere 12/11/2009 19:55'!
waitForTextPresent: someText
	^ (self processCommand: 'waitForTextPresent'
		withParams: (Array with: someText with: self maxWaitTimeForPageToLoadInMillis asString)) = 'true'! !

!WtWebTester methodsFor: 'accessing' stamp: 'LinusDeMeyere 11/26/2009 21:09'!
buttonById: locator
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'JanSabbe 12/22/2009 02:48'!
buttonByValue: value
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'JanSabbe 12/22/2009 02:48'!
buttonByXPath: locator
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'BKBAG 5/16/2009 14:23'!
comboBox: locator
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'LinusDeMeyere 12/11/2009 16:42'!
draggableById: locator
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'LinusDeMeyere 12/11/2009 16:42'!
droppableById: locator
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'bkbag 6/10/2009 17:01'!
frame
	self subclassResponsibility.
	self todo: 'ipv hier self subclassResponsibility moet er een systeem zijn waarbij je zegt welke subclasse voor jouw de WtFrameBuilder implementeert, zodat je deze frame niet moet overschrijven, maar dat dit automatisch gebeurd. '! !

!WtWebTester methodsFor: 'accessing' stamp: 'BKBAG 11/23/2008 21:25'!
isStarted
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'bkbag 4/17/2009 20:48'!
isTextPresent: aString
	self subclassResponsibility ! !

!WtWebTester methodsFor: 'accessing' stamp: 'bkbag 5/20/2009 16:12'!
link: text 
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'bkbag 5/20/2009 16:11'!
linkById: id
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'LinusDeMeyere 1/2/2010 23:16'!
linkByXPath: locator
	self subclassResponsibility! !

!WtWebTester methodsFor: 'actions' stamp: 'bkbag 4/17/2009 20:31'!
openUrl: anUrl
	self subclassResponsibility.! !

!WtWebTester methodsFor: 'initialize-release' stamp: 'BKBAG 11/23/2008 20:07'!
start
	self subclassResponsibility! !

!WtWebTester methodsFor: 'initialize-release' stamp: 'BKBAG 11/23/2008 20:07'!
stop
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'LinusDeMeyere 11/28/2009 17:24'!
textFieldById: locator
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'JanSabbe 12/22/2009 02:41'!
textFieldByLabel: label
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'JanSabbe 12/22/2009 02:35'!
textFieldByXPath: locator
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'bkbag 4/17/2009 20:33'!
title
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'LinusDeMeyere 12/15/2009 19:17'!
waitForElementPresent: locator
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'BKBAG 5/17/2009 17:29'!
waitForPageToLoad
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'LinusDeMeyere 12/12/2009 15:49'!
waitForTextNotPresent: someText
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'LinusDeMeyere 12/11/2009 19:55'!
waitForTextPresent: someText
	self subclassResponsibility! !
